: # -*- perl -*-
eval 'exec perl -w -S $0 ${1+"$@"}'
  if 0;

require 5.004;
use strict;

use lib '.';

use vars qw($CT);

use Getopt::Long;

my $mode = 'rl';

ProcessCommandLine();
InitCommandTerm();
PrintBanner();
$CT->EvalPerl('*sandbox::CT = \$main::CT');
$CT->MainLoop;

sub InitCommandTerm {
  if( $mode eq 'rl' ) {
    eval 'use CommandTerm::Rl;';
    $CT = CommandTerm::Rl->New;
  } elsif( $mode eq 'tk' ) {
    eval 'use CommandTerm::Tk;';
    my $TopLevel = Tk::MainWindow->new;
    $TopLevel->iconname('CommandTerm Test');
    $CT = $TopLevel->CommandTermTk( -toplevel => $TopLevel );
    $CT->pack( -fill => 'both', -expand => 'both' );
  } else {
    warn "Unknown mode '$mode'. Must be either 'rl' or 'tk'.\n";
    Usage();
  }
}

sub ProcessCommandLine {
  my $help;
  my $getopt = GetOptions( 'mode=s'     => \$mode,
                           'help'       => \$help,
                         );

  if( defined $help or not $getopt ) {
    Usage();
  }
}

sub Usage {
  die "Usage: ct.pl -mode <rl | tk>\n",
    "\n",
    "        where '-mode' specifies either run in ReadLine or Tk mode.\n",
    "        The default is ReadLine mode.\n",
    "\n";
}

sub PrintBanner {
my $banner = <<EOF;

                 Welcome to the Command Terminal test program!

          GNU ReadLine is in effect with emacs line editing bindings.
            Hit Control-T to toggle between command and perl modes.
    Hit <TAB><TAB> from either prompt to see a list of possible completions.

EOF
$CT->PrintStatus( $banner ); 
}
